/*
    This file is part of autower, Copyright (C) Christoph Langguth, 2006

    autower is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    autower is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with autower; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <windows.h>

#define AIRPORT_NAME_SIZE 32
#define AIRPORT_COM_SIZE 8

#define DEFAULT_COMLOCKTHRESHOLD 30
#define DEFAULT_MAXDISPLAYINFOALTITUDE 3042
#define DEFAULT_TOWERALT1RW 60
#define DEFAULT_TOWERALT2RW 80
#define DEFAULT_TOWERALT3RW 100
#define DEFAULT_TOWERALT4RW 140
#define DEFAULT_TOWERALT5RW 140
#define DEFAULT_TOWERALT6RW 140
#define DEFAULT_TOWERMINCANDIDATES 100
#define DEFAULT_ZOOMLEVEL 384
#define DEFAULT_UPDATEINTERVAL 5000
#define DEFAULT_DISPLAYDURATION 5
#define DEFAULT_SIMPLEFIXHEADING 90
#define DEFAULT_SIMPLEFIXDISTANCE 10

#define KEY_COMLOCKTHRESHOLD "ComLockThreshold"
#define KEY_MAXDISPLAYINFOALTITUDE "MaxDisplayInfoAltitude"
#define KEY_TOWERALT1RW "TowerHeight1Rw"
#define KEY_TOWERALT2RW "TowerHeight2Rw"
#define KEY_TOWERALT3RW "TowerHeight3Rw"
#define KEY_TOWERALT4RW "TowerHeight4Rw"
#define KEY_TOWERALT5RW "TowerHeight5Rw"
#define KEY_TOWERALT6RW "TowerHeight6Rw"
#define KEY_TOWERMINCANDIDATES "TowerMinCandidates"
#define KEY_ZOOMLEVEL "ZoomLevel"
#define KEY_UPDATEINTERVAL "UpdateInterval"
#define KEY_LOGLEVEL "LogLevel"
#define KEY_DISPLAYDURATION "DisplayDuration"
#define KEY_SIMPLEFIXHEADING "SimpleFixHeading"
#define KEY_SIMPLEFIXDISTANCE "SimpleFixDistance"

#define DATAFILE_REL "autower.dat"
#define INIFILE_REL "autower.ini"
#define INI_SECTIONKEY "AutowerConfig"
#define WINDOW_TITLE "autower 1.04"

#define AIRPORTINFO_VERSION 1
typedef struct _AirportInfo {
	char ICAO[7];
	unsigned char runways;
	char Name[AIRPORT_NAME_SIZE];
	WORD COM[AIRPORT_COM_SIZE];
	DWORD longitude;
	DWORD latitude;
	DWORD altitude;
	DWORD tLongitude;
	DWORD tLatitude;
	DWORD tAltitude;
	float currentDistance;
	float singleRwyInfo;  
} AirportInfo, *PAirportInfo;

void resultCallback(AirportInfo* nextResult);

typedef double ElementType;
typedef ElementType ItemType[ 2 ];

struct KdNode;
typedef struct KdNode *Position;
typedef struct KdNode *KdTree;

struct KdNode
{
	AirportInfo *payload;
	ItemType Data;
	KdTree   Left;
	KdTree   Right;
};


KdTree Insert( ItemType Item, AirportInfo* payload, KdTree T );
void PrintRange( ItemType Low, ItemType High, KdTree T);
